class DiariesController < ApplicationController
  before_action :login_required

  def index
    # @diaries = Diary.all
    @diaries = current_user.diaries
  end

  def show
    # @diary = Diary.find(params[:id])
    @diary = current_user.diaries.find(params[:id])
  end

  def new
    @diary = Diary.new
  end

  def create
    # @diary = Diary.new(diary_params)
    @diary = current_user.diaries.new(diary_params)

    if @diary.save
      redirect_to root_path, notice: "日記「#{@diary.title}」を登録しました。"
    else
      # 登録フォームを再度呼び出す　@diaryというインスタンス変数に入れておけば、newアクションでも使い回せるので、エラーになっても入力内容が保持されたままになる
      render :new
    end


    # デフォルトでは、noticeとalertがある。add_flash_typesで増やせる
    # flash[:notice] = "日記「#{diary.name}」を登録しました。"
    # redirect_to diary_url
    #
    # このリクエスト内ですぐ使いたい場合はnowを使う
    # flash.now[:notice] = "日記「#{diary.name}」を登録しました。"
  end

  def edit
    # @diary = Diary.find(params[:id])
    @diary = current_user.diaries.find(params[:id])
  end

  def update
    diary = Diary.find(params[:id])
    diary.update!(diary_params)
    redirect_to root_path, notice: "日記「#{diary.title}」を編集しました。"
  end

  def destroy
    diary = Diary.find(params[:id])
    diary.destroy
    redirect_to root_path, notice: "日記「#{diary.title}」を削除しました。"
  end

  private

  def diary_params
    # {diary: {...}} のデータ形式で送られてきていて、かつnameとdescriptionだけを抜き出す
    params.require(:diary).permit(:title, :description)
  end

  # ログインしていなければ、ログイン画面にリダイレクトさせる
  def login_required
    redirect_to login_path unless current_user
  end
end
